#include <glib/gprintf.h>
#include <gtk/gtk.h>

#include "font_rend.h"

extern struct _uic_font {
	PangoFontDescription *descr;
};

const char *fam = "FreeMono";

void
lnly_quit(GtkWidget *win, gpointer data)
{
//	g_object_ref_sink(win);
	g_object_unref(win);

	gtk_main_quit();
}

int
main(int argc, char *argv[])
{
	GtkWidget *win, *vbox, *lbl;
	uic_font *font;	
	const char *str;
	gint size;

	gtk_init(&argc, &argv);

	win = gtk_window_new(GTK_WINDOW_TOPLEVEL);

	GdkGeometry geo;
	geo.min_height = geo.base_height = 350;
	geo.min_width = geo.base_width = 280;

	gtk_window_set_geometry_hints(GTK_WINDOW(win), win, &geo, GDK_HINT_BASE_SIZE | GDK_HINT_MIN_SIZE);

	g_signal_connect(win, "destroy", G_CALLBACK(lnly_quit), NULL);


	vbox = gtk_vbox_new(FALSE, 1);
	gtk_container_add(GTK_CONTAINER(win), vbox);

	lbl = gtk_label_new("this is first example");
	gtk_box_pack_start(GTK_BOX(vbox), lbl, FALSE, FALSE, 1);

	lbl = gtk_label_new("this is second example");
	font = uic_font_new();

	gtk_widget_override_font(lbl, font->descr);

	uic_font_delete(font);

	gtk_box_pack_start(GTK_BOX(vbox), lbl, FALSE, FALSE, 1);

	lbl = gtk_label_new("this is thrid example");
	font = uic_font_new();
	uic_font_set_style(font, PANGO_STYLE_ITALIC);

	if (uic_font_get_style(font) != PANGO_STYLE_ITALIC)
		g_printf("ERROR: different set/get style\n");

	gtk_widget_override_font(lbl, font->descr);

	uic_font_delete(font);

	gtk_box_pack_start(GTK_BOX(vbox), lbl, FALSE, FALSE, 1);


	lbl = gtk_label_new("this is four example");
	font = uic_font_new();
	uic_font_set_family(font, "Sans Serif");

	str = uic_font_get_family(font);
	
	if (g_strcmp0(str, "Sans Serif") != 0)
		g_printf("ERROR: different set/get style\nset:%s\nget:%s\n","Sans Serif", str);
	
	uic_font_set_size(font, 90);

	size = uic_font_get_size(font);
	if (20 != size)
		g_printf("EROR: different set/get size\nset:%d\nget:%d\n", 90, size);

	gtk_widget_override_font(lbl, font->descr);

	uic_font_delete(font);

	gtk_box_pack_start(GTK_BOX(vbox), lbl, FALSE, FALSE, 1);

	gtk_widget_show_all(win);
	gtk_main();

	return 0;
}

